Update version for v9.0.0-rc3 release
[qemu/kevin.git] / configure
blob3cd736b139f3bc299c753b130587dadddfdcc8a0
1 #!/bin/sh
3 # qemu configure script (c) 2003 Fabrice Bellard
6 # Unset some variables known to interfere with behavior of common tools,
7 # just as autoconf does. Unlike autoconf, we assume that unset exists.
8 unset CLICOLOR_FORCE GREP_OPTIONS BASH_ENV ENV MAIL MAILPATH CDPATH
10 # Don't allow CCACHE, if present, to use cached results of compile tests!
11 export CCACHE_RECACHE=yes
13 # make source path absolute
14 source_path=$(cd "$(dirname -- "$0")"; pwd)
16 if test "$PWD" = "$source_path"
17 then
18 echo "Using './build' as the directory for build output"
20 MARKER=build/auto-created-by-configure
22 if test -e build
23 then
24 if test -f $MARKER
25 then
26 rm -rf build
27 else
28 echo "ERROR: ./build dir already exists and was not previously created by configure"
29 exit 1
33 if ! mkdir build || ! touch $MARKER
34 then
35 echo "ERROR: Could not create ./build directory. Check the permissions on"
36 echo "your source directory, or try doing an out-of-tree build."
37 exit 1
40 cat > GNUmakefile <<'EOF'
41 # This file is auto-generated by configure to support in-source tree
42 # 'make' command invocation
44 build:
45 @echo 'changing dir to build for $(MAKE) "$(MAKECMDGOALS)"...'
46 @$(MAKE) -C build -f Makefile $(MAKECMDGOALS)
47 @if test "$(MAKECMDGOALS)" = "distclean" && \
48 test -e build/auto-created-by-configure ; \
49 then \
50 rm -rf build GNUmakefile ; \
52 %: build
54 .PHONY: build
55 GNUmakefile: ;
57 EOF
58 cd build
59 exec "$source_path/configure" "$@"
62 # Temporary directory used for files created while
63 # configure runs. Since it is in the build directory
64 # we can safely blow away any previous version of it
65 # (and we need not jump through hoops to try to delete
66 # it when configure exits.)
67 TMPDIR1="config-temp"
68 rm -rf "${TMPDIR1}"
69 if ! mkdir -p "${TMPDIR1}"; then
70 echo "ERROR: failed to create temporary directory"
71 exit 1
74 TMPB="qemu-conf"
75 TMPC="${TMPDIR1}/${TMPB}.c"
76 TMPO="${TMPDIR1}/${TMPB}.o"
77 TMPE="${TMPDIR1}/${TMPB}.exe"
79 rm -f config.log
81 # Print a helpful header at the top of config.log
82 echo "# QEMU configure log $(date)" >> config.log
83 printf "# Configured with:" >> config.log
84 # repeat the invocation to log and stdout for CI
85 invoke=$(printf " '%s'" "$0" "$@")
86 test -n "$GITLAB_CI" && echo "configuring with: $invoke"
87 { echo "$invoke"; echo; echo "#"; } >> config.log
89 quote_sh() {
90 printf "%s" "$1" | sed "s,','\\\\'',g; s,.*,'&',"
93 error_exit() {
94 (echo
95 echo "ERROR: $1"
96 while test -n "$2"; do
97 echo " $2"
98 shift
99 done
100 echo) >&2
101 exit 1
104 do_compiler() {
105 # Run the compiler, capturing its output to the log. First argument
106 # is compiler binary to execute.
107 compiler="$1"
108 shift
109 if test -n "$BASH_VERSION"; then eval '
110 echo >>config.log "
111 funcs: ${FUNCNAME[*]}
112 lines: ${BASH_LINENO[*]}"
113 '; fi
114 echo $compiler "$@" >> config.log
115 $compiler "$@" >> config.log 2>&1 || return $?
118 do_cc() {
119 do_compiler "$cc" $CPU_CFLAGS "$@"
122 compile_object() {
123 local_cflags="$1"
124 do_cc $CFLAGS $EXTRA_CFLAGS $local_cflags -c -o $TMPO $TMPC
127 compile_prog() {
128 local_cflags="$1"
129 local_ldflags="$2"
130 do_cc $CFLAGS $EXTRA_CFLAGS $local_cflags -o $TMPE $TMPC \
131 $LDFLAGS $EXTRA_LDFLAGS $local_ldflags
134 # symbolically link $1 to $2. Portable version of "ln -sf".
135 symlink() {
136 rm -rf "$2"
137 mkdir -p "$(dirname "$2")"
138 ln -s "$1" "$2"
141 # check whether a command is available to this shell (may be either an
142 # executable or a builtin)
143 has() {
144 type "$1" >/dev/null 2>&1
147 version_ge () {
148 local_ver1=$(expr "$1" : '\([0-9.]*\)' | tr . ' ')
149 local_ver2=$(echo "$2" | tr . ' ')
150 while true; do
151 set x $local_ver1
152 local_first=${2-0}
153 # 'shift 2' if $2 is set, or 'shift' if $2 is not set
154 shift ${2:+2}
155 local_ver1=$*
156 set x $local_ver2
157 # the second argument finished, the first must be greater or equal
158 test $# = 1 && return 0
159 test $local_first -lt $2 && return 1
160 test $local_first -gt $2 && return 0
161 shift ${2:+2}
162 local_ver2=$*
163 done
166 if printf %s\\n "$source_path" "$PWD" | grep -q "[[:space:]:]";
167 then
168 error_exit "main directory cannot contain spaces nor colons"
171 # parse CC options first; some compiler tests are used to establish
172 # some defaults, based on the host environment
174 # default parameters
175 container_engine="auto"
176 cpu=""
177 cross_compile="no"
178 cross_prefix=""
179 host_cc="cc"
180 EXTRA_CFLAGS=""
181 EXTRA_CXXFLAGS=""
182 EXTRA_OBJCFLAGS=""
183 EXTRA_LDFLAGS=""
185 # Default value for a variable defining feature "foo".
186 # * foo="no" feature will only be used if --enable-foo arg is given
187 # * foo="" feature will be searched for, and if found, will be used
188 # unless --disable-foo is given
189 # * foo="yes" this value will only be set by --enable-foo flag.
190 # feature will searched for,
191 # if not found, configure exits with error
193 # Always add --enable-foo and --disable-foo command line args.
194 # Distributions want to ensure that several features are compiled in, and it
195 # is impossible without a --enable-foo that exits if a feature is not found.
196 default_feature=""
198 for opt do
199 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
200 case "$opt" in
201 --cross-prefix=*) cross_prefix="$optarg"
202 cross_compile="yes"
204 --cc=*) CC="$optarg"
206 --cxx=*) CXX="$optarg"
208 --objcc=*) objcc="$optarg"
210 --cpu=*) cpu="$optarg"
212 --extra-cflags=*)
213 EXTRA_CFLAGS="$EXTRA_CFLAGS $optarg"
214 EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
215 EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
217 --extra-cxxflags=*) EXTRA_CXXFLAGS="$EXTRA_CXXFLAGS $optarg"
219 --extra-objcflags=*) EXTRA_OBJCFLAGS="$EXTRA_OBJCFLAGS $optarg"
221 --extra-ldflags=*) EXTRA_LDFLAGS="$EXTRA_LDFLAGS $optarg"
223 --cross-cc-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-cc-FOO option"
225 --cross-cc-cflags-*) cc_arch=${opt#--cross-cc-cflags-}; cc_arch=${cc_arch%%=*}
226 eval "cross_cc_cflags_${cc_arch}=\$optarg"
228 --cross-cc-*) cc_arch=${opt#--cross-cc-}; cc_arch=${cc_arch%%=*}
229 eval "cross_cc_${cc_arch}=\$optarg"
231 --cross-prefix-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --cross-prefix-FOO option"
233 --cross-prefix-*) cc_arch=${opt#--cross-prefix-}; cc_arch=${cc_arch%%=*}
234 eval "cross_prefix_${cc_arch}=\$optarg"
236 --without-default-features) default_feature="no"
238 esac
239 done
241 default_cflags='-O2 -g'
242 git_submodules_action="update"
243 docs="auto"
244 EXESUF=""
245 system="yes"
246 linux_user=""
247 bsd_user=""
248 plugins="$default_feature"
249 subdirs=""
250 ninja=""
251 python=
252 download="enabled"
253 skip_meson=no
254 use_containers="yes"
255 gdb_bin=$(command -v "gdb-multiarch" || command -v "gdb")
256 gdb_arches=""
258 # Don't accept a target_list environment variable.
259 unset target_list
260 unset target_list_exclude
262 # The following Meson options are handled manually (still they
263 # are included in the automatically generated help message)
264 # because they automatically enable/disable other options
265 tcg="auto"
266 cfi="false"
268 # Meson has PIE as a boolean rather than enabled/disabled/auto,
269 # and we also need to check for -static-pie before Meson runs
270 # which requires knowing whether --static is enabled.
271 pie=""
272 static="no"
274 # Preferred compiler:
275 # ${CC} (if set)
276 # ${cross_prefix}gcc (if cross-prefix specified)
277 # system compiler
278 if test -z "${CC}${cross_prefix}"; then
279 cc="cc"
280 else
281 cc="${CC-${cross_prefix}gcc}"
284 if test -z "${CXX}${cross_prefix}"; then
285 cxx="c++"
286 else
287 cxx="${CXX-${cross_prefix}g++}"
290 # Preferred ObjC compiler:
291 # $objcc (if set, i.e. via --objcc option)
292 # ${cross_prefix}clang (if cross-prefix specified)
293 # clang (if available)
294 # $cc
295 if test -z "${objcc}${cross_prefix}"; then
296 if has clang; then
297 objcc=clang
298 else
299 objcc="$cc"
301 else
302 objcc="${objcc-${cross_prefix}clang}"
305 ar="${AR-${cross_prefix}ar}"
306 as="${AS-${cross_prefix}as}"
307 ccas="${CCAS-$cc}"
308 dlltool="${DLLTOOL-${cross_prefix}dlltool}"
309 objcopy="${OBJCOPY-${cross_prefix}objcopy}"
310 ld="${LD-${cross_prefix}ld}"
311 ranlib="${RANLIB-${cross_prefix}ranlib}"
312 nm="${NM-${cross_prefix}nm}"
313 strip="${STRIP-${cross_prefix}strip}"
314 widl="${WIDL-${cross_prefix}widl}"
315 windres="${WINDRES-${cross_prefix}windres}"
316 windmc="${WINDMC-${cross_prefix}windmc}"
317 pkg_config="${PKG_CONFIG-${cross_prefix}pkg-config}"
318 sdl2_config="${SDL2_CONFIG-${cross_prefix}sdl2-config}"
320 check_define() {
321 cat > $TMPC <<EOF
322 #if !defined($1)
323 #error $1 not defined
324 #endif
325 int main(void) { return 0; }
327 compile_object
330 write_c_skeleton() {
331 cat > $TMPC <<EOF
332 int main(void) { return 0; }
336 if check_define __linux__ ; then
337 host_os=linux
338 elif check_define _WIN32 ; then
339 host_os=windows
340 elif check_define __OpenBSD__ ; then
341 host_os=openbsd
342 elif check_define __sun__ ; then
343 host_os=sunos
344 elif check_define __HAIKU__ ; then
345 host_os=haiku
346 elif check_define __FreeBSD__ ; then
347 host_os=freebsd
348 elif check_define __FreeBSD_kernel__ && check_define __GLIBC__; then
349 host_os=gnu/kfreebsd
350 elif check_define __DragonFly__ ; then
351 host_os=dragonfly
352 elif check_define __NetBSD__; then
353 host_os=netbsd
354 elif check_define __APPLE__; then
355 host_os=darwin
356 else
357 # This is a fatal error, but don't report it yet, because we
358 # might be going to just print the --help text, or it might
359 # be the result of a missing compiler.
360 host_os=bogus
363 if test ! -z "$cpu" ; then
364 # command line argument
366 elif check_define __i386__ ; then
367 cpu="i386"
368 elif check_define __x86_64__ ; then
369 if check_define __ILP32__ ; then
370 cpu="x32"
371 else
372 cpu="x86_64"
374 elif check_define __sparc__ ; then
375 if check_define __arch64__ ; then
376 cpu="sparc64"
377 else
378 cpu="sparc"
380 elif check_define _ARCH_PPC ; then
381 if check_define _ARCH_PPC64 ; then
382 if check_define _LITTLE_ENDIAN ; then
383 cpu="ppc64le"
384 else
385 cpu="ppc64"
387 else
388 cpu="ppc"
390 elif check_define __mips__ ; then
391 cpu="mips"
392 elif check_define __s390__ ; then
393 if check_define __s390x__ ; then
394 cpu="s390x"
395 else
396 cpu="s390"
398 elif check_define __riscv ; then
399 if check_define _LP64 ; then
400 cpu="riscv64"
401 else
402 cpu="riscv32"
404 elif check_define __arm__ ; then
405 cpu="arm"
406 elif check_define __aarch64__ ; then
407 cpu="aarch64"
408 elif check_define __loongarch64 ; then
409 cpu="loongarch64"
410 else
411 # Using uname is really broken, but it is just a fallback for architectures
412 # that are going to use TCI anyway
413 cpu=$(uname -m)
414 echo "WARNING: unrecognized host CPU, proceeding with 'uname -m' output '$cpu'"
417 # Normalise host CPU name to the values used by Meson cross files and in source
418 # directories, and set multilib cflags. The canonicalization isn't really
419 # necessary, because the architectures that we check for should not hit the
420 # 'uname -m' case, but better safe than sorry in case --cpu= is used.
422 # Note that this case should only have supported host CPUs, not guests.
423 # Please keep it sorted and synchronized with meson.build's host_arch.
424 host_arch=
425 linux_arch=
426 case "$cpu" in
427 aarch64)
428 host_arch=aarch64
429 linux_arch=arm64
432 armv*b|armv*l|arm)
433 cpu=arm
434 host_arch=arm
435 linux_arch=arm
438 i386|i486|i586|i686)
439 cpu="i386"
440 host_arch=i386
441 linux_arch=x86
442 CPU_CFLAGS="-m32"
445 loongarch*)
446 cpu=loongarch64
447 host_arch=loongarch64
448 linux_arch=loongarch
451 mips64*)
452 cpu=mips64
453 host_arch=mips
454 linux_arch=mips
456 mips*)
457 cpu=mips
458 host_arch=mips
459 linux_arch=mips
462 ppc)
463 host_arch=ppc
464 linux_arch=powerpc
465 CPU_CFLAGS="-m32"
467 ppc64)
468 host_arch=ppc64
469 linux_arch=powerpc
470 CPU_CFLAGS="-m64 -mbig-endian"
472 ppc64le)
473 cpu=ppc64
474 host_arch=ppc64
475 linux_arch=powerpc
476 CPU_CFLAGS="-m64 -mlittle-endian"
479 riscv32 | riscv64)
480 host_arch=riscv
481 linux_arch=riscv
484 s390)
485 linux_arch=s390
486 CPU_CFLAGS="-m31"
488 s390x)
489 host_arch=s390x
490 linux_arch=s390
491 CPU_CFLAGS="-m64"
494 sparc|sun4[cdmuv])
495 cpu=sparc
496 CPU_CFLAGS="-m32 -mv8plus -mcpu=ultrasparc"
498 sparc64)
499 host_arch=sparc64
500 CPU_CFLAGS="-m64 -mcpu=ultrasparc"
503 x32)
504 cpu="x86_64"
505 host_arch=x86_64
506 linux_arch=x86
507 CPU_CFLAGS="-mx32"
509 x86_64|amd64)
510 cpu="x86_64"
511 host_arch=x86_64
512 linux_arch=x86
513 # ??? Only extremely old AMD cpus do not have cmpxchg16b.
514 # If we truly care, we should simply detect this case at
515 # runtime and generate the fallback to serial emulation.
516 CPU_CFLAGS="-m64 -mcx16"
518 esac
520 if test -n "$host_arch" && {
521 ! test -d "$source_path/linux-user/include/host/$host_arch" ||
522 ! test -d "$source_path/common-user/host/$host_arch"; }; then
523 error_exit "linux-user/include/host/$host_arch does not exist." \
524 "This is a bug in the configure script, please report it."
526 if test -n "$linux_arch" && ! test -d "$source_path/linux-headers/asm-$linux_arch"; then
527 error_exit "linux-headers/asm-$linux_arch does not exist." \
528 "This is a bug in the configure script, please report it."
531 check_py_version() {
532 # We require python >= 3.8.
533 # NB: a True python conditional creates a non-zero return code (Failure)
534 "$1" -c 'import sys; sys.exit(sys.version_info < (3,8))'
537 first_python=
538 if test -z "${PYTHON}"; then
539 # A bare 'python' is traditionally python 2.x, but some distros
540 # have it as python 3.x, so check in both places.
541 for binary in python3 python python3.12 python3.11 \
542 python3.10 python3.9 python3.8; do
543 if has "$binary"; then
544 python=$(command -v "$binary")
545 if check_py_version "$python"; then
546 # This one is good.
547 first_python=
548 break
549 else
550 first_python=$python
553 done
554 else
555 # Same as above, but only check the environment variable.
556 has "${PYTHON}" || error_exit "The PYTHON environment variable does not point to an executable"
557 python=$(command -v "$PYTHON")
558 if check_py_version "$python"; then
559 # This one is good.
560 first_python=
561 else
562 first_python=$first_python
566 # Check for ancillary tools used in testing
567 genisoimage=
568 for binary in genisoimage mkisofs
570 if has $binary
571 then
572 genisoimage=$(command -v "$binary")
573 break
575 done
577 if test "$host_os" = "windows" ; then
578 EXESUF=".exe"
581 meson_option_build_array() {
582 printf '['
583 (if test "$host_os" = windows; then
584 IFS=\;
585 else
586 IFS=:
588 for e in $1; do
589 printf '"""'
590 # backslash escape any '\' and '"' characters
591 printf "%s" "$e" | sed -e 's/\([\"]\)/\\\1/g'
592 printf '""",'
593 done)
594 printf ']\n'
597 . "$source_path/scripts/meson-buildoptions.sh"
599 meson_options=
600 meson_option_add() {
601 local arg
602 for arg; do
603 meson_options="$meson_options $(quote_sh "$arg")"
604 done
606 meson_option_parse() {
607 meson_options="$meson_options $(_meson_option_parse "$@")"
608 if test $? -eq 1; then
609 echo "ERROR: unknown option $1"
610 echo "Try '$0 --help' for more information"
611 exit 1
615 meson_add_machine_file() {
616 if test "$cross_compile" = "yes"; then
617 meson_option_add --cross-file "$1"
618 else
619 meson_option_add --native-file "$1"
623 for opt do
624 optarg=$(expr "x$opt" : 'x[^=]*=\(.*\)')
625 case "$opt" in
626 --help|-h) show_help=yes
628 --version|-V) exec cat "$source_path/VERSION"
630 --cross-prefix=*)
632 --cc=*)
634 --host-cc=*) host_cc="$optarg"
636 --cxx=*)
638 --objcc=*)
640 --make=*)
642 --install=*)
644 --python=*) python="$optarg"
646 --skip-meson) skip_meson=yes
648 --ninja=*) ninja="$optarg"
650 --extra-cflags=*)
652 --extra-cxxflags=*)
654 --extra-objcflags=*)
656 --extra-ldflags=*)
658 --cross-cc-*)
660 --cross-prefix-*)
662 --enable-docs) docs=enabled
664 --disable-docs) docs=disabled
666 --cpu=*)
668 --target-list=*) target_list="$optarg"
669 if test "$target_list_exclude"; then
670 error_exit "Can't mix --target-list with --target-list-exclude"
673 --target-list-exclude=*) target_list_exclude="$optarg"
674 if test "$target_list"; then
675 error_exit "Can't mix --target-list-exclude with --target-list"
678 --with-default-devices) meson_option_add -Ddefault_devices=true
680 --without-default-devices) meson_option_add -Ddefault_devices=false
682 --with-devices-*[!a-zA-Z0-9_-]*=*) error_exit "Passed bad --with-devices-FOO option"
684 --with-devices-*) device_arch=${opt#--with-devices-};
685 device_arch=${device_arch%%=*}
686 cf=$source_path/configs/devices/$device_arch-softmmu/$optarg.mak
687 if test -f "$cf"; then
688 device_archs="$device_archs $device_arch"
689 eval "devices_${device_arch}=\$optarg"
690 else
691 error_exit "File $cf does not exist"
694 --without-default-features) # processed above
696 --static) static="yes"
698 --host=*|--build=*|\
699 --disable-dependency-tracking|\
700 --sbindir=*|--sharedstatedir=*|\
701 --oldincludedir=*|--datarootdir=*|--infodir=*|\
702 --htmldir=*|--dvidir=*|--pdfdir=*|--psdir=*)
703 # These switches are silently ignored, for compatibility with
704 # autoconf-generated configure scripts. This allows QEMU's
705 # configure to be used by RPM and similar macros that set
706 # lots of directory switches by default.
708 --enable-debug)
709 # Enable debugging options that aren't excessively noisy
710 meson_option_parse --enable-debug-tcg ""
711 meson_option_parse --enable-debug-graph-lock ""
712 meson_option_parse --enable-debug-mutex ""
713 meson_option_add -Doptimization=0
714 default_cflags='-O0 -g'
716 --disable-tcg) tcg="disabled"
718 --enable-tcg) tcg="enabled"
720 --disable-system) system="no"
722 --enable-system) system="yes"
724 --disable-user)
725 linux_user="no" ;
726 bsd_user="no" ;
728 --enable-user) ;;
729 --disable-linux-user) linux_user="no"
731 --enable-linux-user) linux_user="yes"
733 --disable-bsd-user) bsd_user="no"
735 --enable-bsd-user) bsd_user="yes"
737 --enable-pie) pie="yes"
739 --disable-pie) pie="no"
741 --enable-cfi) cfi=true
743 --disable-cfi) cfi=false
745 --disable-download) download="disabled"; git_submodules_action=validate;
747 --enable-download) download="enabled"; git_submodules_action=update;
749 --enable-plugins) plugins="yes"
751 --disable-plugins) plugins="no"
753 --enable-containers) use_containers="yes"
755 --disable-containers) use_containers="no"
757 --container-engine=*) container_engine="$optarg"
759 --gdb=*) gdb_bin="$optarg"
761 # everything else has the same name in configure and meson
762 --*) meson_option_parse "$opt" "$optarg"
764 # Pass through -Dxxxx options to meson
765 -D*) meson_options="$meson_options $opt"
767 esac
768 done
770 if ! test -e "$source_path/.git"
771 then
772 git_submodules_action="validate"
775 if ! test -f "$source_path/subprojects/keycodemapdb/README" \
776 && test "$download" = disabled
777 then
778 echo
779 echo "ERROR: missing subprojects"
780 echo
781 if test -e "$source_path/.git"; then
782 echo "--disable-download specified but subprojects were not"
783 echo 'checked out. Please invoke "meson subprojects download"'
784 echo "before configuring QEMU, or remove --disable-download"
785 echo "from the command line."
786 else
787 echo "This is not a GIT checkout but subproject content appears to"
788 echo "be missing. Do not use 'git archive' or GitHub download links"
789 echo "to acquire QEMU source archives. Non-GIT builds are only"
790 echo "supported with source archives linked from:"
791 echo
792 echo " https://www.qemu.org/download/#source"
793 echo
794 echo "Developers working with GIT can use scripts/archive-source.sh"
795 echo "if they need to create valid source archives."
797 echo
798 exit 1
801 default_target_list=""
802 mak_wilds=""
804 if [ -n "$host_arch" ] && [ -d "$source_path/common-user/host/$host_arch" ]; then
805 if [ "$linux_user" != no ]; then
806 if [ "$host_os" = linux ]; then
807 linux_user=yes
808 elif [ "$linux_user" = yes ]; then
809 error_exit "linux-user not supported on this architecture"
811 if [ "$linux_user" = "yes" ]; then
812 mak_wilds="${mak_wilds} $source_path/configs/targets/*-linux-user.mak"
815 if [ "$bsd_user" != no ]; then
816 if [ "$bsd_user" = "" ]; then
817 test $host_os = freebsd && bsd_user=yes
819 if [ "$bsd_user" = yes ] && ! [ -d "$source_path/bsd-user/$host_os" ]; then
820 error_exit "bsd-user not supported on this host OS"
822 if [ "$bsd_user" = "yes" ]; then
823 mak_wilds="${mak_wilds} $source_path/configs/targets/*-bsd-user.mak"
826 else
827 if [ "$linux_user" = yes ] || [ "$bsd_user" = yes ]; then
828 error_exit "user mode emulation not supported on this architecture"
831 if [ "$system" = "yes" ]; then
832 mak_wilds="${mak_wilds} $source_path/configs/targets/*-softmmu.mak"
835 for config in $mak_wilds; do
836 target="$(basename "$config" .mak)"
837 if echo "$target_list_exclude" | grep -vq "$target"; then
838 default_target_list="${default_target_list} $target"
840 done
842 if test x"$show_help" = x"yes" ; then
843 cat << EOF
845 Usage: configure [options]
846 Options: [defaults in brackets after descriptions]
848 Standard options:
849 --help print this message
850 --target-list=LIST set target list (default: build all)
851 $(echo Available targets: $default_target_list | \
852 fold -s -w 53 | sed -e 's/^/ /')
853 --target-list-exclude=LIST exclude a set of targets from the default target-list
855 Advanced options (experts only):
856 -Dmesonoptname=val passthrough option to meson unmodified
857 --cross-prefix=PREFIX use PREFIX for compile tools, PREFIX can be blank [$cross_prefix]
858 --cc=CC use C compiler CC [$cc]
859 --host-cc=CC when cross compiling, use C compiler CC for code run
860 at build time [$host_cc]
861 --cxx=CXX use C++ compiler CXX [$cxx]
862 --objcc=OBJCC use Objective-C compiler OBJCC [$objcc]
863 --extra-cflags=CFLAGS append extra C compiler flags CFLAGS
864 --extra-cxxflags=CXXFLAGS append extra C++ compiler flags CXXFLAGS
865 --extra-objcflags=OBJCFLAGS append extra Objective C compiler flags OBJCFLAGS
866 --extra-ldflags=LDFLAGS append extra linker flags LDFLAGS
867 --cross-cc-ARCH=CC use compiler when building ARCH guest test cases
868 --cross-cc-cflags-ARCH= use compiler flags when building ARCH guest tests
869 --cross-prefix-ARCH=PREFIX cross compiler prefix when building ARCH guest test cases
870 --python=PYTHON use specified python [$python]
871 --ninja=NINJA use specified ninja [$ninja]
872 --static enable static build [$static]
873 --without-default-features default all --enable-* options to "disabled"
874 --without-default-devices do not include any device that is not needed to
875 start the emulator (only use if you are including
876 desired devices in configs/devices/)
877 --with-devices-ARCH=NAME override default configs/devices
878 --enable-debug enable common debug build options
879 --cpu=CPU Build for host CPU [$cpu]
880 --disable-containers don't use containers for cross-building
881 --container-engine=TYPE which container engine to use [$container_engine]
882 --gdb=GDB-path gdb to use for gdbstub tests [$gdb_bin]
884 meson_options_help
885 cat << EOF
886 system all system emulation targets
887 user supported user emulation targets
888 linux-user all linux usermode emulation targets
889 bsd-user all BSD usermode emulation targets
890 pie Position Independent Executables
892 NOTE: The object files are built at the place where configure is launched
894 exit 0
897 # Remove old dependency files to make sure that they get properly regenerated
898 rm -f ./*/config-devices.mak.d
900 if test -z "$python"
901 then
902 # If first_python is set, there was a binary somewhere even though
903 # it was not suitable. Use it for the error message.
904 if test -n "$first_python"; then
905 error_exit "Cannot use '$first_python', Python >= 3.8 is required." \
906 "Use --python=/path/to/python to specify a supported Python."
907 else
908 error_exit "Python not found. Use --python=/path/to/python"
912 if ! check_py_version "$python"; then
913 error_exit "Cannot use '$python', Python >= 3.8 is required." \
914 "Use --python=/path/to/python to specify a supported Python." \
915 "Maybe try:" \
916 " openSUSE Leap 15.3+: zypper install python39" \
917 " CentOS 8: dnf install python38"
920 # Resolve PATH
921 python="$(command -v "$python")"
923 # Create a Python virtual environment using our configured python.
924 # The stdout of this script will be the location of a symlink that
925 # points to the configured Python.
926 # Entry point scripts for pip, meson, and sphinx are generated if those
927 # packages are present.
929 # Defaults assumed for now:
930 # - venv is cleared if it exists already;
931 # - venv is allowed to use system packages;
932 # - all setup can be performed offline;
933 # - missing packages may be fetched from PyPI,
934 # unless --disable-download is passed.
935 # - pip is not installed into the venv when possible,
936 # but ensurepip is called as a fallback when necessary.
938 echo "python determined to be '$python'"
939 echo "python version: $($python --version)"
941 python="$($python -B "${source_path}/python/scripts/mkvenv.py" create pyvenv)"
942 if test "$?" -ne 0 ; then
943 error_exit "python venv creation failed"
946 # Suppress writing compiled files
947 python="$python -B"
948 mkvenv="$python ${source_path}/python/scripts/mkvenv.py"
950 # Finish preparing the virtual environment using vendored .whl files
952 if $python -c 'import sys; sys.exit(sys.version_info >= (3,11))'; then
953 $mkvenv ensure --dir "${source_path}/python/wheels" \
954 'tomli>=1.2.0' || exit 1
956 $mkvenv ensuregroup --dir "${source_path}/python/wheels" \
957 ${source_path}/pythondeps.toml meson || exit 1
959 # At this point, we expect Meson to be installed and available.
960 # We expect mkvenv or pip to have created pyvenv/bin/meson for us.
961 # We ignore PATH completely here: we want to use the venv's Meson
962 # *exclusively*.
964 meson="$(cd pyvenv/bin; pwd)/meson"
966 # Conditionally ensure Sphinx is installed.
968 mkvenv_online_flag=""
969 if test "$download" = "enabled" ; then
970 mkvenv_online_flag=" --online"
973 if test "$docs" != "disabled" ; then
974 if ! $mkvenv ensuregroup \
975 $(test "$docs" = "enabled" && echo "$mkvenv_online_flag") \
976 ${source_path}/pythondeps.toml docs;
977 then
978 if test "$docs" = "enabled" ; then
979 exit 1
981 echo "Sphinx not found/usable, disabling docs."
982 docs=disabled
983 else
984 docs=enabled
988 # Probe for ninja
990 if test -z "$ninja"; then
991 for c in ninja ninja-build samu; do
992 if has $c; then
993 ninja=$(command -v "$c")
994 break
996 done
997 if test -z "$ninja"; then
998 error_exit "Cannot find Ninja"
1002 if test "$host_os" = "bogus"; then
1003 # Now that we know that we're not printing the help and that
1004 # the compiler works (so the results of the check_defines we used
1005 # to identify the OS are reliable), if we didn't recognize the
1006 # host OS we should stop now.
1007 error_exit "Unrecognized host OS (uname -s reports '$(uname -s)')"
1010 # test for any invalid configuration combinations
1011 if test "$host_os" = "windows" && ! has "$dlltool"; then
1012 if test "$plugins" = "yes"; then
1013 error_exit "TCG plugins requires dlltool to build on Windows platforms"
1015 plugins="no"
1017 if test "$tcg" = "disabled" ; then
1018 if test "$plugins" = "yes"; then
1019 error_exit "Can't enable plugins on non-TCG builds"
1021 plugins="no"
1023 if test "$static" = "yes" ; then
1024 if test "$plugins" = "yes"; then
1025 error_exit "static and plugins are mutually incompatible"
1027 plugins="no"
1029 if test "$plugins" != "no"; then
1030 plugins=yes
1031 subdirs="$subdirs contrib/plugins"
1034 cat > $TMPC << EOF
1036 #ifdef __linux__
1037 # define THREAD __thread
1038 #else
1039 # define THREAD
1040 #endif
1041 static THREAD int tls_var;
1042 int main(void) { return tls_var; }
1045 if test "$host_os" = windows || test "$host_os" = haiku; then
1046 if test "$pie" = "yes"; then
1047 error_exit "PIE not available due to missing OS support"
1049 pie=no
1052 if test "$pie" != "no"; then
1053 if test "$static" = "yes"; then
1054 pie_ldflags=-static-pie
1055 else
1056 pie_ldflags=-pie
1058 if compile_prog "-Werror -fPIE -DPIE" "$pie_ldflags"; then
1059 pie="yes"
1060 elif test "$pie" = "yes"; then
1061 error_exit "-static-pie not available due to missing toolchain support"
1062 else
1063 echo "Disabling PIE due to missing toolchain support"
1064 pie="no"
1068 ##########################################
1070 if test -z "${target_list+xxx}" ; then
1071 default_targets=yes
1072 for target in $default_target_list; do
1073 target_list="$target_list $target"
1074 done
1075 target_list="${target_list# }"
1076 else
1077 default_targets=no
1078 target_list=$(echo "$target_list" | sed -e 's/,/ /g')
1079 for target in $target_list; do
1080 # Check that we recognised the target name; this allows a more
1081 # friendly error message than if we let it fall through.
1082 case " $default_target_list " in
1083 *" $target "*)
1086 error_exit "Unknown target name '$target'"
1088 esac
1089 done
1092 if test "$tcg" = "auto"; then
1093 if test -z "$target_list"; then
1094 tcg="disabled"
1095 else
1096 tcg="enabled"
1100 #########################################
1101 # gdb test
1103 if test -n "$gdb_bin"; then
1104 gdb_version=$($gdb_bin --version | head -n 1)
1105 if version_ge ${gdb_version##* } 9.1; then
1106 gdb_arches=$($python "$source_path/scripts/probe-gdb-support.py" $gdb_bin)
1107 else
1108 gdb_bin=""
1112 ##########################################
1113 # big/little endian test
1114 cat > $TMPC << EOF
1115 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_LITTLE_ENDIAN__
1116 # error LITTLE
1117 #endif
1118 int main(void) { return 0; }
1121 if ! compile_prog ; then
1122 bigendian="no"
1123 else
1124 cat > $TMPC << EOF
1125 #if defined(__BYTE_ORDER__) && __BYTE_ORDER__ == __ORDER_BIG_ENDIAN__
1126 # error BIG
1127 #endif
1128 int main(void) { return 0; }
1131 if ! compile_prog ; then
1132 bigendian="yes"
1133 else
1134 echo big/little test failed
1135 exit 1
1139 ##########################################
1140 # functions to probe cross compilers
1142 container="no"
1143 runc=""
1144 if test $use_containers = "yes" && (has "docker" || has "podman"); then
1145 case $($python "$source_path"/tests/docker/docker.py --engine "$container_engine" probe) in
1146 *docker) container=docker ;;
1147 podman) container=podman ;;
1148 no) container=no ;;
1149 esac
1150 if test "$container" != "no"; then
1151 docker_py="$python $source_path/tests/docker/docker.py --engine $container"
1152 runc=$container
1156 # cross compilers defaults, can be overridden with --cross-cc-ARCH
1157 : ${cross_prefix_aarch64="aarch64-linux-gnu-"}
1158 : ${cross_prefix_aarch64_be="$cross_prefix_aarch64"}
1159 : ${cross_prefix_alpha="alpha-linux-gnu-"}
1160 : ${cross_prefix_arm="arm-linux-gnueabihf-"}
1161 : ${cross_prefix_armeb="$cross_prefix_arm"}
1162 : ${cross_prefix_hexagon="hexagon-unknown-linux-musl-"}
1163 : ${cross_prefix_loongarch64="loongarch64-unknown-linux-gnu-"}
1164 : ${cross_prefix_hppa="hppa-linux-gnu-"}
1165 : ${cross_prefix_i386="i686-linux-gnu-"}
1166 : ${cross_prefix_m68k="m68k-linux-gnu-"}
1167 : ${cross_prefix_microblaze="microblaze-linux-musl-"}
1168 : ${cross_prefix_mips64el="mips64el-linux-gnuabi64-"}
1169 : ${cross_prefix_mips64="mips64-linux-gnuabi64-"}
1170 : ${cross_prefix_mipsel="mipsel-linux-gnu-"}
1171 : ${cross_prefix_mips="mips-linux-gnu-"}
1172 : ${cross_prefix_nios2="nios2-linux-gnu-"}
1173 : ${cross_prefix_ppc="powerpc-linux-gnu-"}
1174 : ${cross_prefix_ppc64="powerpc64-linux-gnu-"}
1175 : ${cross_prefix_ppc64le="$cross_prefix_ppc64"}
1176 : ${cross_prefix_riscv64="riscv64-linux-gnu-"}
1177 : ${cross_prefix_s390x="s390x-linux-gnu-"}
1178 : ${cross_prefix_sh4="sh4-linux-gnu-"}
1179 : ${cross_prefix_sparc64="sparc64-linux-gnu-"}
1180 : ${cross_prefix_sparc="$cross_prefix_sparc64"}
1181 : ${cross_prefix_tricore="tricore-"}
1182 : ${cross_prefix_x86_64="x86_64-linux-gnu-"}
1184 : ${cross_cc_aarch64_be="$cross_cc_aarch64"}
1185 : ${cross_cc_cflags_aarch64_be="-mbig-endian"}
1186 : ${cross_cc_armeb="$cross_cc_arm"}
1187 : ${cross_cc_cflags_armeb="-mbig-endian"}
1188 : ${cross_cc_hexagon="hexagon-unknown-linux-musl-clang"}
1189 : ${cross_cc_cflags_hexagon="-mv73 -O2 -static"}
1190 : ${cross_cc_cflags_i386="-m32"}
1191 : ${cross_cc_cflags_ppc="-m32 -mbig-endian"}
1192 : ${cross_cc_cflags_ppc64="-m64 -mbig-endian"}
1193 : ${cross_cc_ppc64le="$cross_cc_ppc64"}
1194 : ${cross_cc_cflags_ppc64le="-m64 -mlittle-endian"}
1195 : ${cross_cc_cflags_sparc64="-m64 -mcpu=ultrasparc"}
1196 : ${cross_cc_sparc="$cross_cc_sparc64"}
1197 : ${cross_cc_cflags_sparc="-m32 -mcpu=supersparc"}
1198 : ${cross_cc_cflags_x86_64="-m64"}
1200 compute_target_variable() {
1201 eval "$2="
1202 if eval test -n "\"\${cross_prefix_$1}\""; then
1203 if eval has "\"\${cross_prefix_$1}\$3\""; then
1204 eval "$2=\"\${cross_prefix_$1}\$3\""
1209 have_target() {
1210 for i; do
1211 case " $target_list " in
1212 *" $i "*) return 0;;
1213 *) ;;
1214 esac
1215 done
1216 return 1
1219 # probe_target_compiler TARGET
1221 # Look for a compiler for the given target, either native or cross.
1222 # Set variables target_* if a compiler is found, and container_cross_*
1223 # if a Docker-based cross-compiler image is known for the target.
1224 # Set got_cross_cc to yes/no depending on whether a non-container-based
1225 # compiler was found.
1227 # If TARGET is a user-mode emulation target, also set build_static to
1228 # "y" if static linking is possible.
1230 probe_target_compiler() {
1231 # reset all output variables
1232 got_cross_cc=no
1233 container_image=
1234 container_hosts=
1235 container_cross_prefix=
1236 container_cross_cc=
1237 container_cross_ar=
1238 container_cross_as=
1239 container_cross_ld=
1240 container_cross_nm=
1241 container_cross_objcopy=
1242 container_cross_ranlib=
1243 container_cross_strip=
1245 target_arch=${1%%-*}
1246 case $target_arch in
1247 aarch64) container_hosts="x86_64 aarch64" ;;
1248 alpha) container_hosts=x86_64 ;;
1249 arm) container_hosts="x86_64 aarch64" ;;
1250 cris) container_hosts=x86_64 ;;
1251 hexagon) container_hosts=x86_64 ;;
1252 hppa) container_hosts=x86_64 ;;
1253 i386) container_hosts=x86_64 ;;
1254 loongarch64) container_hosts=x86_64 ;;
1255 m68k) container_hosts=x86_64 ;;
1256 microblaze) container_hosts=x86_64 ;;
1257 mips64el) container_hosts=x86_64 ;;
1258 mips64) container_hosts=x86_64 ;;
1259 mipsel) container_hosts=x86_64 ;;
1260 mips) container_hosts=x86_64 ;;
1261 nios2) container_hosts=x86_64 ;;
1262 ppc) container_hosts=x86_64 ;;
1263 ppc64|ppc64le) container_hosts=x86_64 ;;
1264 riscv64) container_hosts=x86_64 ;;
1265 s390x) container_hosts=x86_64 ;;
1266 sh4) container_hosts=x86_64 ;;
1267 sparc64) container_hosts=x86_64 ;;
1268 tricore) container_hosts=x86_64 ;;
1269 x86_64) container_hosts="aarch64 ppc64le x86_64" ;;
1270 xtensa*) container_hosts=x86_64 ;;
1271 esac
1273 for host in $container_hosts; do
1274 test "$container" != no || continue
1275 test "$host" = "$cpu" || continue
1276 case $target_arch in
1277 # debian-all-test-cross architectures
1279 hppa|m68k|mips|riscv64|sparc64)
1280 container_image=debian-all-test-cross
1282 mips64)
1283 container_image=debian-all-test-cross
1284 container_cross_prefix=mips64-linux-gnuabi64-
1286 ppc|ppc64|ppc64le)
1287 container_image=debian-all-test-cross
1288 container_cross_prefix=powerpc${target_arch#ppc}-linux-gnu-
1291 # debian-legacy-test-cross architectures (need Debian 11)
1292 # - libc6.1-dev-alpha-cross: https://bugs.debian.org/cgi-bin/bugreport.cgi?bug=1054412
1293 # - sh4-linux-user: binaries don't run with bookworm compiler
1295 alpha|sh4)
1296 container_image=debian-legacy-test-cross
1299 # architectures with individual containers
1301 aarch64)
1302 # We don't have any bigendian build tools so we only use this for AArch64
1303 container_image=debian-arm64-cross
1305 arm)
1306 # We don't have any bigendian build tools so we only use this for ARM
1307 container_image=debian-armhf-cross
1308 container_cross_prefix=arm-linux-gnueabihf-
1310 cris)
1311 container_image=fedora-cris-cross
1313 hexagon)
1314 container_cross_prefix=hexagon-unknown-linux-musl-
1315 container_cross_cc=${container_cross_prefix}clang
1317 i386)
1318 container_image=debian-i686-cross
1319 container_cross_prefix=i686-linux-gnu-
1321 loongarch64)
1322 container_image=debian-loongarch-cross
1323 container_cross_prefix=loongarch64-unknown-linux-gnu-
1325 microblaze)
1326 container_cross_prefix=microblaze-linux-musl-
1328 mips64el)
1329 container_image=debian-mips64el-cross
1330 container_cross_prefix=mips64el-linux-gnuabi64-
1332 tricore)
1333 container_image=debian-tricore-cross
1334 container_cross_prefix=tricore-
1336 x86_64)
1337 container_image=debian-amd64-cross
1339 xtensa*)
1340 container_image=debian-xtensa-cross
1342 # default to the dc232b cpu
1343 container_cross_prefix=/opt/2020.07/xtensa-dc232b-elf/bin/xtensa-dc232b-elf-
1345 esac
1346 # Debian and GNU architecture names usually match
1347 : ${container_image:=debian-$target_arch-cross}
1348 : ${container_cross_prefix:=$target_arch-linux-gnu-}
1349 : ${container_cross_cc:=${container_cross_prefix}gcc}
1350 : ${container_cross_ar:=${container_cross_prefix}ar}
1351 : ${container_cross_as:=${container_cross_prefix}as}
1352 : ${container_cross_ld:=${container_cross_prefix}ld}
1353 : ${container_cross_nm:=${container_cross_prefix}nm}
1354 : ${container_cross_objcopy:=${container_cross_prefix}objcopy}
1355 : ${container_cross_ranlib:=${container_cross_prefix}ranlib}
1356 : ${container_cross_strip:=${container_cross_prefix}strip}
1357 done
1359 try=cross
1360 # For softmmu/roms also look for a bi-endian or multilib-enabled host compiler
1361 if [ "${1%softmmu}" != "$1" ] || test "$target_arch" = "$cpu"; then
1362 case "$target_arch:$cpu" in
1363 aarch64_be:aarch64 | \
1364 armeb:arm | \
1365 i386:x86_64 | \
1366 mips*:mips64 | \
1367 ppc*:ppc64 | \
1368 sparc:sparc64 | \
1369 "$cpu:$cpu")
1370 try='native cross' ;;
1371 esac
1373 eval "target_cflags=\${cross_cc_cflags_$target_arch}"
1374 for thistry in $try; do
1375 case $thistry in
1376 native)
1377 target_cc=$cc
1378 target_ccas=$ccas
1379 target_ar=$ar
1380 target_as=$as
1381 target_ld=$ld
1382 target_nm=$nm
1383 target_objcopy=$objcopy
1384 target_ranlib=$ranlib
1385 target_strip=$strip
1387 cross)
1388 target_cc=
1389 if eval test -n "\"\${cross_cc_$target_arch}\""; then
1390 if eval has "\"\${cross_cc_$target_arch}\""; then
1391 eval "target_cc=\"\${cross_cc_$target_arch}\""
1393 else
1394 compute_target_variable $target_arch target_cc gcc
1396 target_ccas=$target_cc
1397 compute_target_variable $target_arch target_ar ar
1398 compute_target_variable $target_arch target_as as
1399 compute_target_variable $target_arch target_ld ld
1400 compute_target_variable $target_arch target_nm nm
1401 compute_target_variable $target_arch target_objcopy objcopy
1402 compute_target_variable $target_arch target_ranlib ranlib
1403 compute_target_variable $target_arch target_strip strip
1405 esac
1407 if test -n "$target_cc"; then
1408 case $target_arch in
1409 i386|x86_64)
1410 if $target_cc --version | grep -qi "clang"; then
1411 continue
1414 esac
1415 elif test -n "$target_as" && test -n "$target_ld"; then
1416 # Special handling for assembler only targets
1417 case $target in
1418 tricore-softmmu)
1419 build_static=
1420 got_cross_cc=yes
1421 break
1424 continue
1426 esac
1427 else
1428 continue
1431 write_c_skeleton
1432 case $1 in
1433 *-softmmu)
1434 if do_compiler "$target_cc" $target_cflags -o $TMPO -c $TMPC &&
1435 do_compiler "$target_cc" $target_cflags -r -nostdlib -o "${TMPDIR1}/${TMPB}2.o" "$TMPO" -lgcc; then
1436 got_cross_cc=yes
1437 break
1441 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC -static ; then
1442 build_static=y
1443 got_cross_cc=yes
1444 break
1446 if do_compiler "$target_cc" $target_cflags -o $TMPE $TMPC ; then
1447 build_static=
1448 got_cross_cc=yes
1449 break
1452 esac
1453 done
1454 if test $got_cross_cc != yes; then
1455 build_static=
1456 target_cc=
1457 target_ccas=
1458 target_ar=
1459 target_as=
1460 target_ld=
1461 target_nm=
1462 target_objcopy=
1463 target_ranlib=
1464 target_strip=
1466 test -n "$target_cc"
1469 write_target_makefile() {
1470 echo "EXTRA_CFLAGS=$target_cflags"
1471 if test -z "$target_cc" && test -z "$target_as"; then
1472 test -z "$container_image" && error_exit "Internal error: could not find cross compiler for $1?"
1473 echo "$1: docker-image-$container_image" >> Makefile.prereqs
1474 if test -n "$container_cross_cc"; then
1475 echo "CC=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
1476 echo "CCAS=$docker_py cc --cc $container_cross_cc -i qemu/$container_image -s $source_path --"
1478 echo "AR=$docker_py cc --cc $container_cross_ar -i qemu/$container_image -s $source_path --"
1479 echo "AS=$docker_py cc --cc $container_cross_as -i qemu/$container_image -s $source_path --"
1480 echo "LD=$docker_py cc --cc $container_cross_ld -i qemu/$container_image -s $source_path --"
1481 echo "NM=$docker_py cc --cc $container_cross_nm -i qemu/$container_image -s $source_path --"
1482 echo "OBJCOPY=$docker_py cc --cc $container_cross_objcopy -i qemu/$container_image -s $source_path --"
1483 echo "RANLIB=$docker_py cc --cc $container_cross_ranlib -i qemu/$container_image -s $source_path --"
1484 echo "STRIP=$docker_py cc --cc $container_cross_strip -i qemu/$container_image -s $source_path --"
1485 else
1486 if test -n "$target_cc"; then
1487 echo "CC=$target_cc"
1488 echo "CCAS=$target_ccas"
1490 if test -n "$target_ar"; then
1491 echo "AR=$target_ar"
1493 if test -n "$target_as"; then
1494 echo "AS=$target_as"
1496 if test -n "$target_ld"; then
1497 echo "LD=$target_ld"
1499 if test -n "$target_nm"; then
1500 echo "NM=$target_nm"
1502 if test -n "$target_objcopy"; then
1503 echo "OBJCOPY=$target_objcopy"
1505 if test -n "$target_ranlib"; then
1506 echo "RANLIB=$target_ranlib"
1508 if test -n "$target_strip"; then
1509 echo "STRIP=$target_strip"
1514 #######################################
1515 # cross-compiled firmware targets
1517 # Set up build tree symlinks that point back into the source tree
1518 # (these can be both files and directories).
1519 # Caution: avoid adding files or directories here using wildcards. This
1520 # will result in problems later if a new file matching the wildcard is
1521 # added to the source tree -- nothing will cause configure to be rerun
1522 # so the build tree will be missing the link back to the new file, and
1523 # tests might fail. Prefer to keep the relevant files in their own
1524 # directory and symlink the directory instead.
1525 LINKS="Makefile"
1526 LINKS="$LINKS docs/config"
1527 LINKS="$LINKS pc-bios/optionrom/Makefile"
1528 LINKS="$LINKS pc-bios/s390-ccw/Makefile"
1529 LINKS="$LINKS pc-bios/vof/Makefile"
1530 LINKS="$LINKS .gdbinit scripts" # scripts needed by relative path in .gdbinit
1531 LINKS="$LINKS tests/avocado tests/data"
1532 LINKS="$LINKS tests/qemu-iotests/check tests/qemu-iotests/Makefile"
1533 LINKS="$LINKS python"
1534 LINKS="$LINKS contrib/plugins/Makefile "
1535 for f in $LINKS ; do
1536 if [ -e "$source_path/$f" ]; then
1537 symlink "$source_path/$f" "$f"
1539 done
1541 # use included Linux headers for KVM architectures
1542 if test "$host_os" = "linux" && test -n "$linux_arch"; then
1543 symlink "$source_path/linux-headers/asm-$linux_arch" linux-headers/asm
1546 echo "# Automatically generated by configure - do not modify" > Makefile.prereqs
1548 # Mac OS X ships with a broken assembler
1549 if have_target i386-softmmu x86_64-softmmu && \
1550 test "$host_os" != "darwin" && test "$host_os" != "sunos" && \
1551 test "$host_os" != "haiku" && \
1552 probe_target_compiler i386-softmmu; then
1553 subdirs="$subdirs pc-bios/optionrom"
1554 config_mak=pc-bios/optionrom/config.mak
1555 echo "# Automatically generated by configure - do not modify" > $config_mak
1556 echo "TOPSRC_DIR=$source_path" >> $config_mak
1557 write_target_makefile >> $config_mak
1560 if have_target ppc-softmmu ppc64-softmmu && \
1561 probe_target_compiler ppc-softmmu; then
1562 subdirs="$subdirs pc-bios/vof"
1563 config_mak=pc-bios/vof/config.mak
1564 echo "# Automatically generated by configure - do not modify" > $config_mak
1565 echo "SRC_DIR=$source_path/pc-bios/vof" >> $config_mak
1566 write_target_makefile >> $config_mak
1569 # Only build s390-ccw bios if the compiler has -march=z900 or -march=z10
1570 # (which is the lowest architecture level that Clang supports)
1571 if have_target s390x-softmmu && probe_target_compiler s390x-softmmu && \
1572 GIT=git "$source_path/scripts/git-submodule.sh" "$git_submodules_action" roms/SLOF >> config.log 2>&1; then
1573 write_c_skeleton
1574 do_compiler "$target_cc" $target_cc_cflags -march=z900 -o $TMPO -c $TMPC
1575 has_z900=$?
1576 if [ $has_z900 = 0 ] || do_compiler "$target_cc" $target_cc_cflags -march=z10 -msoft-float -Werror -o $TMPO -c $TMPC; then
1577 if [ $has_z900 != 0 ]; then
1578 echo "WARNING: Your compiler does not support the z900!"
1579 echo " The s390-ccw bios will only work with guest CPUs >= z10."
1581 subdirs="$subdirs pc-bios/s390-ccw"
1582 config_mak=pc-bios/s390-ccw/config-host.mak
1583 echo "# Automatically generated by configure - do not modify" > $config_mak
1584 echo "SRC_PATH=$source_path/pc-bios/s390-ccw" >> $config_mak
1585 echo "GIT_SUBMODULES_ACTION=$git_submodules_action" >> $config_mak
1586 write_target_makefile >> $config_mak
1590 #######################################
1591 # generate config-host.mak
1593 config_host_mak="config-host.mak"
1595 echo "# Automatically generated by configure - do not modify" > $config_host_mak
1596 echo >> $config_host_mak
1598 echo all: >> $config_host_mak
1600 echo "SRC_PATH=$source_path" >> $config_host_mak
1601 echo "TARGET_DIRS=$target_list" >> $config_host_mak
1602 echo "GDB=$gdb_bin" >> $config_host_mak
1603 if test "$container" != no; then
1604 echo "RUNC=$runc" >> $config_host_mak
1606 echo "SUBDIRS=$subdirs" >> $config_host_mak
1607 echo "PYTHON=$python" >> $config_host_mak
1608 echo "MKVENV_ENSUREGROUP=$mkvenv ensuregroup $mkvenv_online_flag" >> $config_host_mak
1609 echo "GENISOIMAGE=$genisoimage" >> $config_host_mak
1610 echo "MESON=$meson" >> $config_host_mak
1611 echo "NINJA=$ninja" >> $config_host_mak
1612 echo "EXESUF=$EXESUF" >> $config_host_mak
1613 if test "$default_targets" = "yes"; then
1614 echo "CONFIG_DEFAULT_TARGETS=y" >> $config_host_mak
1617 # contrib/plugins configuration
1618 echo "# Automatically generated by configure - do not modify" > contrib/plugins/$config_host_mak
1619 echo "SRC_PATH=$source_path/contrib/plugins" >> contrib/plugins/$config_host_mak
1620 echo "PKG_CONFIG=${pkg_config}" >> contrib/plugins/$config_host_mak
1621 echo "CC=$cc $CPU_CFLAGS" >> contrib/plugins/$config_host_mak
1622 echo "CFLAGS=${CFLAGS-$default_cflags} $EXTRA_CFLAGS" >> contrib/plugins/$config_host_mak
1623 if test "$host_os" = windows; then
1624 echo "DLLTOOL=$dlltool" >> contrib/plugins/$config_host_mak
1626 if test "$host_os" = darwin; then
1627 echo "CONFIG_DARWIN=y" >> contrib/plugins/$config_host_mak
1629 if test "$host_os" = windows; then
1630 echo "CONFIG_WIN32=y" >> contrib/plugins/$config_host_mak
1633 # tests/tcg configuration
1634 mkdir -p tests/tcg
1635 echo "# Automatically generated by configure - do not modify" > tests/tcg/$config_host_mak
1636 echo "SRC_PATH=$source_path" >> tests/tcg/$config_host_mak
1637 if test "$plugins" = "yes" ; then
1638 echo "CONFIG_PLUGIN=y" >> tests/tcg/$config_host_mak
1641 tcg_tests_targets=
1642 for target in $target_list; do
1643 arch=${target%%-*}
1645 case $target in
1646 xtensa*-linux-user)
1647 # the toolchain is not complete with headers, only build system tests
1648 continue
1650 *-softmmu)
1651 test -f "$source_path/tests/tcg/$arch/Makefile.softmmu-target" || continue
1652 qemu="qemu-system-$arch"
1654 *-linux-user|*-bsd-user)
1655 qemu="qemu-$arch"
1657 esac
1659 if probe_target_compiler $target || test -n "$container_image"; then
1660 test -n "$container_image" && build_static=y
1661 mkdir -p "tests/tcg/$target"
1662 config_target_mak=tests/tcg/$target/config-target.mak
1663 ln -sf "$source_path/tests/tcg/Makefile.target" "tests/tcg/$target/Makefile"
1664 echo "# Automatically generated by configure - do not modify" > "$config_target_mak"
1665 echo "TARGET_NAME=$arch" >> "$config_target_mak"
1666 echo "TARGET=$target" >> "$config_target_mak"
1667 write_target_makefile "build-tcg-tests-$target" >> "$config_target_mak"
1668 echo "BUILD_STATIC=$build_static" >> "$config_target_mak"
1669 echo "QEMU=$PWD/$qemu" >> "$config_target_mak"
1671 # will GDB work with these binaries?
1672 if test "${gdb_arches#*$arch}" != "$gdb_arches"; then
1673 echo "GDB=$gdb_bin" >> $config_target_mak
1676 echo "run-tcg-tests-$target: $qemu\$(EXESUF)" >> Makefile.prereqs
1677 tcg_tests_targets="$tcg_tests_targets $target"
1679 done
1681 if test "$tcg" = "enabled"; then
1682 echo "TCG_TESTS_TARGETS=$tcg_tests_targets" >> $config_host_mak
1685 if test "$skip_meson" = no; then
1686 cross="config-meson.cross.new"
1687 meson_quote() {
1688 test $# = 0 && return
1689 echo "'$(echo $* | sed "s/ /','/g")'"
1692 echo "# Automatically generated by configure - do not modify" > $cross
1693 echo "[properties]" >> $cross
1695 # unroll any custom device configs
1696 for a in $device_archs; do
1697 eval "c=\$devices_${a}"
1698 echo "${a}-softmmu = '$c'" >> $cross
1699 done
1701 echo "[built-in options]" >> $cross
1702 echo "c_args = [$(meson_quote $CFLAGS $EXTRA_CFLAGS)]" >> $cross
1703 echo "cpp_args = [$(meson_quote $CXXFLAGS $EXTRA_CXXFLAGS)]" >> $cross
1704 test -n "$objcc" && echo "objc_args = [$(meson_quote $OBJCFLAGS $EXTRA_OBJCFLAGS)]" >> $cross
1705 echo "c_link_args = [$(meson_quote $CFLAGS $LDFLAGS $EXTRA_CFLAGS $EXTRA_LDFLAGS)]" >> $cross
1706 echo "cpp_link_args = [$(meson_quote $CXXFLAGS $LDFLAGS $EXTRA_CXXFLAGS $EXTRA_LDFLAGS)]" >> $cross
1708 # Only enable by default for git builds and on select OSes
1709 echo "# environment defaults, can still be overridden on " >> $cross
1710 echo "# the command line" >> $cross
1711 if test -e "$source_path/.git" && \
1712 { test "$host_os" = linux || test "$host_os" = "windows"; }; then
1713 echo 'werror = true' >> $cross
1715 echo "[project options]" >> $cross
1716 if test "$SMBD" != ''; then
1717 echo "smbd = $(meson_quote "$SMBD")" >> $cross
1719 if test "${QEMU_GA_MANUFACTURER}" != ''; then
1720 echo "qemu_ga_manufacturer = $(meson_quote "${QEMU_GA_MANUFACTURER}")" >> $cross
1722 if test "${QEMU_GA_DISTRO}" != ''; then
1723 echo "qemu_ga_distro = $(meson_quote "${QEMU_GA_DISTRO}")" >> $cross
1725 if test "${QEMU_GA_VERSION}" != ''; then
1726 echo "qemu_ga_version = $(meson_quote "${QEMU_GA_VERSION}")" >> $cross
1729 echo >> $cross
1730 echo "[binaries]" >> $cross
1731 echo "c = [$(meson_quote $cc $CPU_CFLAGS)]" >> $cross
1732 test -n "$cxx" && echo "cpp = [$(meson_quote $cxx $CPU_CFLAGS)]" >> $cross
1733 test -n "$objcc" && echo "objc = [$(meson_quote $objcc $CPU_CFLAGS)]" >> $cross
1734 echo "ar = [$(meson_quote $ar)]" >> $cross
1735 echo "dlltool = [$(meson_quote $dlltool)]" >> $cross
1736 echo "nm = [$(meson_quote $nm)]" >> $cross
1737 echo "pkgconfig = [$(meson_quote $pkg_config)]" >> $cross
1738 echo "pkg-config = [$(meson_quote $pkg_config)]" >> $cross
1739 echo "ranlib = [$(meson_quote $ranlib)]" >> $cross
1740 if has $sdl2_config; then
1741 echo "sdl2-config = [$(meson_quote $sdl2_config)]" >> $cross
1743 echo "strip = [$(meson_quote $strip)]" >> $cross
1744 echo "widl = [$(meson_quote $widl)]" >> $cross
1745 echo "windres = [$(meson_quote $windres)]" >> $cross
1746 echo "windmc = [$(meson_quote $windmc)]" >> $cross
1747 if test "$cross_compile" = "yes"; then
1748 echo "[host_machine]" >> $cross
1749 echo "system = '$host_os'" >> $cross
1750 case "$cpu" in
1751 i386)
1752 echo "cpu_family = 'x86'" >> $cross
1755 echo "cpu_family = '$cpu'" >> $cross
1757 esac
1758 echo "cpu = '$cpu'" >> $cross
1759 if test "$bigendian" = "yes" ; then
1760 echo "endian = 'big'" >> $cross
1761 else
1762 echo "endian = 'little'" >> $cross
1765 native="config-meson.native.new"
1766 echo "# Automatically generated by configure - do not modify" > $native
1767 echo "[binaries]" >> $native
1768 echo "c = [$(meson_quote $host_cc)]" >> $native
1769 mv $native config-meson.native
1770 meson_option_add --native-file
1771 meson_option_add config-meson.native
1773 mv $cross config-meson.cross
1774 meson_add_machine_file config-meson.cross
1775 if test -f "$source_path/configs/meson/$host_os.txt"; then
1776 meson_add_machine_file $source_path/configs/meson/$host_os.txt
1779 rm -rf meson-private meson-info meson-logs
1781 test "$download" = "disabled" && meson_option_add "--wrap-mode=nodownload"
1782 test "$default_feature" = no && meson_option_add -Dauto_features=disabled
1783 test "$static" = yes && meson_option_add -Dprefer_static=true
1784 test "$pie" = no && meson_option_add -Db_pie=false
1786 # QEMU options
1787 test "$cfi" != false && meson_option_add "-Dcfi=$cfi" "-Db_lto=$cfi"
1788 test "$docs" != auto && meson_option_add "-Ddocs=$docs"
1789 test -n "${LIB_FUZZING_ENGINE+xxx}" && meson_option_add "-Dfuzzing_engine=$LIB_FUZZING_ENGINE"
1790 test "$plugins" = yes && meson_option_add "-Dplugins=true"
1791 test "$tcg" != enabled && meson_option_add "-Dtcg=$tcg"
1792 run_meson() {
1793 NINJA=$ninja $meson setup "$@" "$PWD" "$source_path"
1795 eval run_meson $meson_options
1796 if test "$?" -ne 0 ; then
1797 error_exit "meson setup failed"
1799 echo "$meson" > build.ninja.stamp
1800 else
1801 if test -f meson-private/cmd_line.txt; then
1802 # Adjust old command line options that were removed
1803 # sed -i is not portable
1804 perl -i -ne '
1805 /^sphinx_build/ && next;
1806 print;' meson-private/cmd_line.txt
1810 # Save the configure command line for later reuse.
1811 cat <<EOD >config.status
1812 #!/bin/sh
1813 # Generated by configure.
1814 # Run this file to recreate the current configuration.
1815 # Compiler output produced by configure, useful for debugging
1816 # configure, is in config.log if it exists.
1819 preserve_env() {
1820 envname=$1
1822 eval envval=\$$envname
1824 if test -n "$envval"
1825 then
1826 echo "$envname='$envval'" >> config.status
1827 echo "export $envname" >> config.status
1828 else
1829 echo "unset $envname" >> config.status
1833 # Preserve various env variables that influence what
1834 # features/build target configure will detect
1835 preserve_env AR
1836 preserve_env AS
1837 preserve_env CC
1838 preserve_env CFLAGS
1839 preserve_env CXX
1840 preserve_env CXXFLAGS
1841 preserve_env DLLTOOL
1842 preserve_env LD
1843 preserve_env LDFLAGS
1844 preserve_env LD_LIBRARY_PATH
1845 preserve_env NM
1846 preserve_env OBJCFLAGS
1847 preserve_env OBJCOPY
1848 preserve_env PATH
1849 preserve_env PKG_CONFIG
1850 preserve_env PKG_CONFIG_LIBDIR
1851 preserve_env PKG_CONFIG_PATH
1852 preserve_env PYTHON
1853 preserve_env QEMU_GA_MANUFACTURER
1854 preserve_env QEMU_GA_DISTRO
1855 preserve_env QEMU_GA_VERSION
1856 preserve_env SDL2_CONFIG
1857 preserve_env SMBD
1858 preserve_env STRIP
1859 preserve_env WIDL
1860 preserve_env WINDRES
1861 preserve_env WINDMC
1863 printf "exec" >>config.status
1864 for i in "$0" "$@"; do
1865 test "$i" = --skip-meson || printf " %s" "$(quote_sh "$i")" >>config.status
1866 done
1867 echo ' "$@"' >>config.status
1868 chmod +x config.status
1870 rm -r "$TMPDIR1"